/*
 * ARJ+xenu is based on open-source ARJ by Andrew Belov <andrew_belov@newmail.ru>.
 *
 * Copyright (C) 2011 Tomasz Konojacki <xenu@poczta.onet.pl>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * ---------------------------------------------------------------------------
 * Prototypes of the functions located in ARJSEC_H.C are declared here.
 *
 */

#ifndef ARJSEC_H_INCLUDED
#define ARJSEC_H_INCLUDED

#define ARJSEC_SIG_MAXLEN        80     /* Maximum signature length */

/* Prototypes */

int get_arjsec_signature(FILE *stream, long offset, char *signature, int iter);
int verify_reg_name(char *key1, char *key2, char *name, char *validation);
void create_reg_key(char *key1, char *key2, char *name, char *validation);

#endif
