/*
 * ARJ+xenu is based on open-source ARJ by Andrew Belov <andrew_belov@newmail.ru>.
 *
 * Copyright (C) 2011 Tomasz Konojacki <xenu@poczta.onet.pl>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * ---------------------------------------------------------------------------
 * Interface to the CRC32 module.
 *
 */

#ifndef CRC32_INCLUDED
#define CRC32_INCLUDED

/* The following are externals exported from assembly-language routines: */

extern unsigned long crc32term;
#ifdef TILED
 extern unsigned short crc32tab_lo[256];
 extern unsigned short crc32tab_hi[256];
#else
 extern unsigned long crc32tab[256];
#endif

/* Platform-independent CRC macro */

#ifdef TILED
 #define get_crc32tab(i) ((((unsigned long)crc32tab_hi[i])<<16L)+(unsigned long)crc32tab_lo[i])
#else
 #define get_crc32tab(i) crc32tab[i]
#endif

/* Prototypes */

void build_crc32_table();
void crc32_for_block(char *block, unsigned int size);
void crc32_for_string(char *str);
unsigned long crc32_for_char(unsigned long crc32_term, unsigned char c);
unsigned long rev_crc32_for_char(unsigned long crc32_term, unsigned char c);
unsigned long afl_mul(unsigned long term, unsigned long multiplier);

#endif
