/*
 * ARJ+xenu is based on open-source ARJ by Andrew Belov <andrew_belov@newmail.ru>.
 *
 * Copyright (C) 2011 Tomasz Konojacki <xenu@poczta.onet.pl>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * ---------------------------------------------------------------------------
 * Prototypes of the functions located in NTSTREAM.C are declared here.
 *
 *
 */

#ifndef NTSTREAM_INCLUDED
#define NTSTREAM_INCLUDED

#if TARGET==WIN32

/* Read/write (backup/restore) modes */

#define NTSTREAMS_READ             0
#define NTSTREAMS_WRITE            1

/* NT stream operations structure */

struct nt_sid
{
 HANDLE hf;                             /* Win32 file handle */
 LARGE_INTEGER rem;                     /* Bytes remaining in xaction */
 int is_write;                          /* 1 = write */
 LPVOID lpcontext;                      /* !NULL = need to finalize */
};

/* Prototypes */

struct nt_sid *open_streams(char *name, int is_write);
void close_streams(struct nt_sid *sid);
int next_stream(WIN32_STREAM_ID *dest, struct nt_sid *sid);
unsigned long seek_stream_id(DWORD id, struct nt_sid *sid);
unsigned long read_stream(unsigned char *dest, unsigned long bytes, struct nt_sid *sid);
int create_stream(WIN32_STREAM_ID *src, struct nt_sid *sid);
unsigned long write_stream(unsigned char *src, unsigned long bytes, struct nt_sid *sid);

#endif  /* TARGET==WIN32 */

#endif
